Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/mm/page_ht.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,12 +48,13 @@
 #include <synch/spinlock.h>
 #include <arch.h>
-#include <debug.h>
-#include <memstr.h>
+#include <assert.h>
+#include <adt/hash.h>
 #include <adt/hash_table.h>
 #include <align.h>
 
-static size_t hash(sysarg_t[]);
-static bool compare(sysarg_t[], size_t, link_t *);
-static void remove_callback(link_t *);
+static size_t ht_hash(const ht_link_t *);
+static size_t ht_key_hash(void *);
+static bool ht_key_equal(void *, const ht_link_t *);
+static void ht_remove_callback(ht_link_t *);
 
 static void ht_mapping_insert(as_t *, uintptr_t, uintptr_t, unsigned int);
@@ -81,8 +82,9 @@
 
 /** Hash table operations for page hash table. */
-hash_table_operations_t ht_operations = {
-	.hash = hash,
-	.compare = compare,
-	.remove_callback = remove_callback
+hash_table_ops_t ht_ops = {
+	.hash = ht_hash,
+	.key_hash = ht_key_hash,
+	.key_equal = ht_key_equal,
+	.remove_callback = ht_remove_callback
 };
 
@@ -96,61 +98,31 @@
 };
 
-/** Compute page hash table index.
- *
- * @param key Array of two keys (i.e. page and address space).
- *
- * @return Index into page hash table.
- *
- */
-size_t hash(sysarg_t key[])
-{
-	as_t *as = (as_t *) key[KEY_AS];
-	uintptr_t page = (uintptr_t) key[KEY_PAGE];
-	
-	/*
-	 * Virtual page addresses have roughly the same probability
-	 * of occurring. Least significant bits of VPN compose the
-	 * hash index.
-	 *
-	 */
-	size_t index = ((page >> PAGE_WIDTH) & (PAGE_HT_ENTRIES - 1));
-	
-	/*
-	 * Address space structures are likely to be allocated from
-	 * similar addresses. Least significant bits compose the
-	 * hash index.
-	 *
-	 */
-	index |= ((sysarg_t) as) & (PAGE_HT_ENTRIES - 1);
-	
-	return index;
-}
-
-/** Compare page hash table item with page and/or address space.
- *
- * @param key  Array of one or two keys (i.e. page and/or address space).
- * @param keys Number of keys passed.
- * @param item Item to compare the keys with.
- *
- * @return true on match, false otherwise.
- *
- */
-bool compare(sysarg_t key[], size_t keys, link_t *item)
-{
-	ASSERT(item);
-	ASSERT(keys > 0);
-	ASSERT(keys <= PAGE_HT_KEYS);
-	
-	/*
-	 * Convert item to PTE.
-	 *
-	 */
-	pte_t *pte = hash_table_get_instance(item, pte_t, link);
-	
-	if (keys == PAGE_HT_KEYS)
-		return (key[KEY_AS] == (uintptr_t) pte->as) &&
-		    (key[KEY_PAGE] == pte->page);
-	
-	return (key[KEY_AS] == (uintptr_t) pte->as);
+/** Return the hash of the key stored in the item */
+size_t ht_hash(const ht_link_t *item)
+{
+	pte_t *pte = hash_table_get_inst(item, pte_t, link);
+	size_t hash = 0;
+	hash = hash_combine(hash, (uintptr_t) pte->as);
+	hash = hash_combine(hash, pte->page >> PAGE_WIDTH);
+	return hash;
+}
+
+/** Return the hash of the key. */
+size_t ht_key_hash(void *arg)
+{
+	uintptr_t *key = (uintptr_t *) arg;
+	size_t hash = 0;
+	hash = hash_combine(hash, key[KEY_AS]);
+	hash = hash_combine(hash, key[KEY_PAGE] >> PAGE_WIDTH);
+	return hash;
+}
+
+/** Return true if the key is equal to the item's lookup key. */
+bool ht_key_equal(void *arg, const ht_link_t *item)
+{
+	uintptr_t *key = (uintptr_t *) arg;
+	pte_t *pte = hash_table_get_inst(item, pte_t, link);
+	return (key[KEY_AS] == (uintptr_t) pte->as) &&
+	    (key[KEY_PAGE] == pte->page);
 }
 
@@ -160,14 +132,9 @@
  *
  */
-void remove_callback(link_t *item)
-{
-	ASSERT(item);
-	
-	/*
-	 * Convert item to PTE.
-	 *
-	 */
-	pte_t *pte = hash_table_get_instance(item, pte_t, link);
-	
+void ht_remove_callback(ht_link_t *item)
+{
+	assert(item);
+	
+	pte_t *pte = hash_table_get_inst(item, pte_t, link);
 	slab_free(pte_cache, pte);
 }
@@ -187,10 +154,10 @@
     unsigned int flags)
 {
-	sysarg_t key[2] = {
-		(uintptr_t) as,
-		page = ALIGN_DOWN(page, PAGE_SIZE)
+	uintptr_t key[2] = {
+		[KEY_AS] = (uintptr_t) as,
+		[KEY_PAGE] = ALIGN_DOWN(page, PAGE_SIZE)
 	};
 
-	ASSERT(page_table_locked(as));
+	assert(page_table_locked(as));
 
 	irq_spinlock_lock(&page_ht_lock, true);
@@ -198,5 +165,5 @@
 	if (!hash_table_find(&page_ht, key)) {
 		pte_t *pte = slab_alloc(pte_cache, FRAME_LOWMEM | FRAME_ATOMIC);
-		ASSERT(pte != NULL);
+		assert(pte != NULL);
 		
 		pte->g = (flags & PAGE_GLOBAL) != 0;
@@ -219,5 +186,5 @@
 		write_barrier();
 		
-		hash_table_insert(&page_ht, key, &pte->link);
+		hash_table_insert(&page_ht, &pte->link);
 	}
 
@@ -237,10 +204,10 @@
 void ht_mapping_remove(as_t *as, uintptr_t page)
 {
-	sysarg_t key[2] = {
-		(uintptr_t) as,
-		page = ALIGN_DOWN(page, PAGE_SIZE)
+	uintptr_t key[2] = {
+		[KEY_AS] = (uintptr_t) as,
+		[KEY_PAGE] = ALIGN_DOWN(page, PAGE_SIZE)
 	};
 
-	ASSERT(page_table_locked(as));
+	assert(page_table_locked(as));
 	
 	irq_spinlock_lock(&page_ht_lock, true);
@@ -250,21 +217,22 @@
 	 * by remove_callback().
 	 */
-	hash_table_remove(&page_ht, key, 2);
+	hash_table_remove(&page_ht, key);
 
 	irq_spinlock_unlock(&page_ht_lock, true);
 }
 
-static pte_t *ht_mapping_find_internal(as_t *as, uintptr_t page, bool nolock)
-{
-	sysarg_t key[2] = {
-		(uintptr_t) as,
-		page = ALIGN_DOWN(page, PAGE_SIZE)
+static pte_t *
+ht_mapping_find_internal(as_t *as, uintptr_t page, bool nolock)
+{
+	uintptr_t key[2] = {
+		[KEY_AS] = (uintptr_t) as,
+		[KEY_PAGE] = ALIGN_DOWN(page, PAGE_SIZE)
 	};
 
-	ASSERT(nolock || page_table_locked(as));
-
-	link_t *cur = hash_table_find(&page_ht, key);
+	assert(nolock || page_table_locked(as));
+
+	ht_link_t *cur = hash_table_find(&page_ht, key);
 	if (cur)
-		return hash_table_get_instance(cur, pte_t, link);
+		return hash_table_get_inst(cur, pte_t, link);
 	
 	return NULL;
@@ -308,13 +276,13 @@
 		panic("Updating non-existent PTE");
 	
-	ASSERT(pte->as == t->as);
-	ASSERT(pte->page == t->page);
-	ASSERT(pte->frame == t->frame);
-	ASSERT(pte->g == t->g);
-	ASSERT(pte->x == t->x);
-	ASSERT(pte->w == t->w);
-	ASSERT(pte->k == t->k);
-	ASSERT(pte->c == t->c);
-	ASSERT(pte->p == t->p);
+	assert(pte->as == t->as);
+	assert(pte->page == t->page);
+	assert(pte->frame == t->frame);
+	assert(pte->g == t->g);
+	assert(pte->x == t->x);
+	assert(pte->w == t->w);
+	assert(pte->k == t->k);
+	assert(pte->c == t->c);
+	assert(pte->p == t->p);
 
 	t->a = pte->a;
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/mm/page_pt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
  */
 
+#include <assert.h>
 #include <genarch/mm/page_pt.h>
 #include <mm/page.h>
@@ -46,5 +47,5 @@
 #include <typedefs.h>
 #include <arch/asm.h>
-#include <memstr.h>
+#include <mem.h>
 #include <align.h>
 #include <macros.h>
@@ -81,5 +82,5 @@
 	pte_t *ptl0 = (pte_t *) PA2KA((uintptr_t) as->genarch.page_table);
 
-	ASSERT(page_table_locked(as));
+	assert(page_table_locked(as));
 	
 	if (GET_PTL1_FLAGS(ptl0, PTL0_INDEX(page)) & PAGE_NOT_PRESENT) {
@@ -159,5 +160,5 @@
 void pt_mapping_remove(as_t *as, uintptr_t page)
 {
-	ASSERT(page_table_locked(as));
+	assert(page_table_locked(as));
 
 	/*
@@ -293,5 +294,5 @@
 static pte_t *pt_mapping_find_internal(as_t *as, uintptr_t page, bool nolock)
 {
-	ASSERT(nolock || page_table_locked(as));
+	assert(nolock || page_table_locked(as));
 
 	pte_t *ptl0 = (pte_t *) PA2KA((uintptr_t) as->genarch.page_table);
@@ -358,9 +359,9 @@
 		panic("Updating non-existent PTE");	
 
-	ASSERT(PTE_VALID(t) == PTE_VALID(pte));
-	ASSERT(PTE_PRESENT(t) == PTE_PRESENT(pte));
-	ASSERT(PTE_GET_FRAME(t) == PTE_GET_FRAME(pte));
-	ASSERT(PTE_WRITABLE(t) == PTE_WRITABLE(pte));
-	ASSERT(PTE_EXECUTABLE(t) == PTE_EXECUTABLE(pte));
+	assert(PTE_VALID(t) == PTE_VALID(pte));
+	assert(PTE_PRESENT(t) == PTE_PRESENT(pte));
+	assert(PTE_GET_FRAME(t) == PTE_GET_FRAME(pte));
+	assert(PTE_WRITABLE(t) == PTE_WRITABLE(pte));
+	assert(PTE_EXECUTABLE(t) == PTE_EXECUTABLE(pte));
 
 	*t = *pte;
@@ -398,5 +399,5 @@
 void pt_mapping_make_global(uintptr_t base, size_t size)
 {
-	ASSERT(size > 0);
+	assert(size > 0);
 	
 	uintptr_t ptl0 = PA2KA((uintptr_t) AS_KERNEL->genarch.page_table);
@@ -416,5 +417,5 @@
 	    addr += ptl0_step) {
 		if (GET_PTL1_ADDRESS(ptl0, PTL0_INDEX(addr)) != 0) {
-			ASSERT(overlaps(addr, ptl0_step,
+			assert(overlaps(addr, ptl0_step,
 			    config.identity_base, config.identity_size));
 
Index: kernel/genarch/src/multiboot/common.c
===================================================================
--- kernel/genarch/src/multiboot/common.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/genarch/src/multiboot/common.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#include <genarch/multiboot/multiboot.h>
+#include <config.h>
+#include <stddef.h>
+
+void multiboot_cmdline(const char *cmdline)
+{
+	/*
+	 * GRUB passes the command line in an escaped form.
+	 */
+	for (size_t i = 0, j = 0;
+	    cmdline[i] && j < CONFIG_BOOT_ARGUMENTS_BUFLEN;
+	    i++, j++) {
+		if (cmdline[i] == '\\') {
+			switch (cmdline[i + 1]) {
+			case '\\':
+			case '\'':
+			case '\"':
+				i++;
+				break;
+			}
+		}
+		bargs[j] = cmdline[i];
+	}
+}
+
+/** @}
+ */
Index: kernel/genarch/src/multiboot/multiboot.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/multiboot/multiboot.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #include <genarch/multiboot/multiboot.h>
 #include <config.h>
+#include <stddef.h>
 #include <str.h>
 
@@ -98,25 +99,4 @@
 
 	str_ncpy(buf, size, start, (size_t) (end - start));
-}
-
-static void multiboot_cmdline(char *cmdline)
-{
-	/*
-	 * GRUB passes the command line in an escaped form.
-	 */
-	for (size_t i = 0, j = 0;
-	    cmdline[i] && j < CONFIG_BOOT_ARGUMENTS_BUFLEN;
-	    i++, j++) {
-		if (cmdline[i] == '\\') {
-			switch (cmdline[i + 1]) {
-			case '\\':
-			case '\'':
-			case '\"':
-				i++;
-				break;
-			}
-		}
-		bargs[j] = cmdline[i];
-	} 
 }
 
Index: kernel/genarch/src/multiboot/multiboot2.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot2.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/multiboot/multiboot2.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,4 +41,9 @@
 
 #define MULTIBOOT2_TAG_ALIGN  8
+
+static void multiboot2_cmdline(const multiboot2_cmdline_t *module)
+{
+	multiboot_cmdline(module->string);
+}
 
 static void multiboot2_module(const multiboot2_module_t *module)
@@ -117,4 +122,7 @@
 	while (tag->type != MULTIBOOT2_TAG_TERMINATOR) {
 		switch (tag->type) {
+		case MULTIBOOT2_TAG_CMDLINE:
+			multiboot2_cmdline(&tag->cmdline);
+			break;
 		case MULTIBOOT2_TAG_MODULE:
 			multiboot2_module(&tag->module);
Index: kernel/genarch/src/ofw/ebus.c
===================================================================
--- kernel/genarch/src/ofw/ebus.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/ofw/ebus.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
  */
 
+#include <assert.h>
 #include <genarch/ofw/ofw_tree.h>
 #include <genarch/ofw/ebus.h>
@@ -41,5 +42,4 @@
 #include <str.h>
 #include <panic.h>
-#include <debug.h>
 #include <macros.h>
 
@@ -94,5 +94,5 @@
 	size_t count = prop->size / sizeof(ofw_ebus_intr_map_t);
 	
-	ASSERT(count);
+	assert(count);
 	
 	prop = ofw_tree_getprop(node, "interrupt-map-mask");
@@ -102,5 +102,5 @@
 	ofw_ebus_intr_mask_t *intr_mask = prop->value;
 	
-	ASSERT(prop->size == sizeof(ofw_ebus_intr_mask_t));
+	assert(prop->size == sizeof(ofw_ebus_intr_mask_t));
 	
 	uint32_t space = reg->space & intr_mask->space_mask;
Index: kernel/genarch/src/ofw/ofw_tree.c
===================================================================
--- kernel/genarch/src/ofw/ofw_tree.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/ofw/ofw_tree.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #include <mm/slab.h>
 #include <sysinfo/sysinfo.h>
-#include <memstr.h>
+#include <mem.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/srln/srln.c
===================================================================
--- kernel/genarch/src/srln/srln.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/genarch/src/srln/srln.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <assert.h>
 #include <genarch/srln/srln.h>
 #include <console/chardev.h>
@@ -148,6 +149,6 @@
 indev_t *srln_wire(srln_instance_t *instance, indev_t *sink)
 {
-	ASSERT(instance);
-	ASSERT(sink);
+	assert(instance);
+	assert(sink);
 	
 	instance->sink = sink;
Index: kernel/generic/include/adt/avl.h
===================================================================
--- kernel/generic/include/adt/avl.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/adt/avl.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,7 @@
 #define KERN_AVLTREE_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <trace.h>
 
Index: kernel/generic/include/adt/bitmap.h
===================================================================
--- kernel/generic/include/adt/bitmap.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/adt/bitmap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_BITMAP_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
 #define BITMAP_ELEMENT   8
Index: kernel/generic/include/adt/btree.h
===================================================================
--- kernel/generic/include/adt/btree.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/adt/btree.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #define KERN_BTREE_H_
 
-#include <typedefs.h>
 #include <adt/list.h>
+#include <stddef.h>
 
 #define BTREE_M		5
@@ -81,5 +81,5 @@
 	link_t leaf_link;
 
-	/* Variables needed by btree_print(). */	
+	/* Variables needed by btree_print(). */
 	link_t bfs_link;
 	int depth;
Index: kernel/generic/include/adt/hash_table.h
===================================================================
--- kernel/generic/include/adt/hash_table.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/adt/hash_table.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -1,4 +1,6 @@
 /*
  * Copyright (c) 2006 Jakub Jermar
+ * Copyright (c) 2012 Adam Hraska
+ * 
  * All rights reserved.
  *
@@ -27,5 +29,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup libc
  * @{
  */
@@ -33,53 +35,70 @@
  */
 
-#ifndef KERN_HASH_TABLE_H_
-#define KERN_HASH_TABLE_H_
+#ifndef LIBC_HASH_TABLE_H_
+#define LIBC_HASH_TABLE_H_
 
 #include <adt/list.h>
-#include <typedefs.h>
+#include <stdbool.h>
+#include <macros.h>
+
+/** Opaque hash table link type. */
+typedef struct ht_link {
+	link_t link;
+} ht_link_t;
 
 /** Set of operations for hash table. */
 typedef struct {
-	/** Hash function.
-	 *
-	 * @param key 	Array of keys needed to compute hash index. All keys must
-	 * 		be passed.
-	 *
-	 * @return Index into hash table.
-	 */
-	size_t (* hash)(sysarg_t key[]);
+	/** Returns the hash of the key stored in the item (ie its lookup key). */
+	size_t (*hash)(const ht_link_t *item);
 	
-	/** Hash table item comparison function.
-	 *
-	 * @param key 	Array of keys that will be compared with item. It is not
-	 *		necessary to pass all keys.
-	 *
-	 * @return true if the keys match, false otherwise.
-	 */
-	bool (*compare)(sysarg_t key[], size_t keys, link_t *item);
+	/** Returns the hash of the key. */
+	size_t (*key_hash)(void *key);
+	
+	/** True if the items are equal (have the same lookup keys). */
+	bool (*equal)(const ht_link_t *item1, const ht_link_t *item2);
+
+	/** Returns true if the key is equal to the item's lookup key. */
+	bool (*key_equal)(void *key, const ht_link_t *item);
 
 	/** Hash table item removal callback.
+	 * 
+	 * Must not invoke any mutating functions of the hash table.
 	 *
 	 * @param item Item that was removed from the hash table.
 	 */
-	void (*remove_callback)(link_t *item);
-} hash_table_operations_t;
+	void (*remove_callback)(ht_link_t *item);
+} hash_table_ops_t;
 
 /** Hash table structure. */
 typedef struct {
-	list_t *entry;
-	size_t entries;
-	size_t max_keys;
-	hash_table_operations_t *op;
+	hash_table_ops_t *op;
+	list_t *bucket;
+	size_t bucket_cnt;
+	size_t full_item_cnt;
+	size_t item_cnt;
+	size_t max_load;
+	bool apply_ongoing;
 } hash_table_t;
 
-#define hash_table_get_instance(item, type, member) \
-	list_get_instance((item), type, member)
+#define hash_table_get_inst(item, type, member) \
+	member_to_inst((item), type, member)
 
-extern void hash_table_create(hash_table_t *h, size_t m, size_t max_keys,
-    hash_table_operations_t *op);
-extern void hash_table_insert(hash_table_t *h, sysarg_t key[], link_t *item);
-extern link_t *hash_table_find(hash_table_t *h, sysarg_t key[]);
-extern void hash_table_remove(hash_table_t *h, sysarg_t key[], size_t keys);
+extern bool hash_table_create(hash_table_t *, size_t, size_t, 
+	hash_table_ops_t *);
+extern void hash_table_destroy(hash_table_t *);
+
+extern bool hash_table_empty(hash_table_t *);
+extern size_t hash_table_size(hash_table_t *);
+
+extern void hash_table_clear(hash_table_t *);
+extern void hash_table_insert(hash_table_t *, ht_link_t *);
+extern bool hash_table_insert_unique(hash_table_t *, ht_link_t *);
+extern ht_link_t *hash_table_find(const hash_table_t *, void *);
+extern ht_link_t *hash_table_find_next(const hash_table_t *, ht_link_t *);
+extern size_t hash_table_remove(hash_table_t *, void *);
+extern void hash_table_remove_item(hash_table_t *, ht_link_t *);
+extern void hash_table_apply(hash_table_t *, bool (*)(ht_link_t *, void *), 
+	void *);
+
 
 #endif
Index: kernel/generic/include/adt/list.h
===================================================================
--- kernel/generic/include/adt/list.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/adt/list.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,7 @@
 #define KERN_LIST_H_
 
-#include <debug.h>
-#include <typedefs.h>
+#include <assert.h>
+#include <stdbool.h>
+#include <stddef.h>
 #include <trace.h>
 
@@ -52,10 +53,8 @@
 } list_t;
 
-
 extern bool list_member(const link_t *, const list_t *);
 extern void list_splice(list_t *, link_t *);
 extern unsigned long list_count(const list_t *);
 
-
 /** Declare and initialize statically allocated list.
  *
@@ -64,5 +63,23 @@
  */
 #define LIST_INITIALIZE(name) \
-	list_t name = { \
+	list_t name = LIST_INITIALIZER(name)
+
+/** Initializer for statically allocated list.
+ * 
+ * @code
+ * struct named_list {
+ *     const char *name;
+ *     list_t list;
+ * } var = { 
+ *     .name = "default name", 
+ *     .list = LIST_INITIALIZER(name_list.list) 
+ * };
+ * @endcode
+ *
+ * @param name Name of the new statically allocated list.
+ *
+ */
+#define LIST_INITIALIZER(name) \
+	{ \
 		.head = { \
 			.prev = &(name).head, \
@@ -87,5 +104,5 @@
 
 /** Unlike list_foreach(), allows removing items while traversing a list.
- * 
+ *
  * @code
  * list_t mylist;
@@ -117,7 +134,12 @@
 	    iterator = next_iter, next_iter = iterator->next)
 
-	
 #define assert_link_not_used(link) \
-	ASSERT(!link_used(link))
+	assert(!link_used(link))
+
+/** Returns true if the link is definitely part of a list. False if not sure. */
+static inline bool link_in_use(const link_t *link)
+{
+	return link->prev != NULL && link->next != NULL;
+}
 
 /** Initialize doubly-linked circular list link
@@ -246,7 +268,7 @@
  *
  */
-static inline link_t *list_last(list_t *list)
-{
-	return ((list->head.prev == &list->head) ? NULL : list->head.prev);
+static inline link_t *list_last(const list_t *list)
+{
+	return (list->head.prev == &list->head) ? NULL : list->head.prev;
 }
 
@@ -258,5 +280,5 @@
  * @return Next item or NULL if @a link is the last item.
  */
-static inline link_t *list_next(link_t *link, const list_t *list)
+static inline link_t *list_next(const link_t *link, const list_t *list)
 {
 	return (link->next == &list->head) ? NULL : link->next;
@@ -270,5 +292,5 @@
  * @return Previous item or NULL if @a link is the first item.
  */
-static inline link_t *list_prev(link_t *link, const list_t *list)
+static inline link_t *list_prev(const link_t *link, const list_t *list)
 {
 	return (link->prev == &list->head) ? NULL : link->prev;
@@ -353,10 +375,9 @@
  *
  */
-static inline link_t *list_nth(list_t *list, unsigned long n)
+static inline link_t *list_nth(const list_t *list, unsigned long n)
 {
 	unsigned long cnt = 0;
-	link_t *link;
 	
-	link = list_first(list);
+	link_t *link = list_first(list);
 	while (link != NULL) {
 		if (cnt == n)
@@ -389,5 +410,5 @@
 		return false;
 
-	ASSERT(link->prev != NULL && link->next != NULL);
+	assert(link->prev != NULL && link->next != NULL);
 	return true;
 }
Index: kernel/generic/include/assert.h
===================================================================
--- kernel/generic/include/assert.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/assert.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,93 @@
+/*
+ * Copyright (c) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericdebug
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ASSERT_H_
+#define KERN_ASSERT_H_
+
+#include <panic.h>
+
+#ifdef CONFIG_DEBUG
+
+/** Debugging assert macro
+ *
+ * If CONFIG_DEBUG is set, the assert() macro
+ * evaluates expr and if it is false raises
+ * kernel panic.
+ *
+ * @param expr Expression which is expected to be true.
+ *
+ */
+#define assert(expr) \
+	do { \
+		if (!(expr)) \
+			panic_assert("%s() at %s:%u:\n%s", \
+			    __func__, __FILE__, __LINE__, #expr); \
+	} while (0)
+
+/** Debugging verbose assert macro
+ *
+ * If CONFIG_DEBUG is set, the assert_verbose() macro
+ * evaluates expr and if it is false raises
+ * kernel panic. The panic message contains also
+ * the supplied message.
+ *
+ * @param expr Expression which is expected to be true.
+ * @param msg  Additional message to show (string).
+ *
+ */
+#define assert_verbose(expr, msg) \
+	do { \
+		if (!(expr)) \
+			panic_assert("%s() at %s:%u:\n%s, %s", \
+			    __func__, __FILE__, __LINE__, #expr, msg); \
+	} while (0)
+
+/** Static assert macro
+ *
+ */
+#define static_assert \
+	_Static_assert
+
+#else /* CONFIG_DEBUG */
+
+#define assert(expr)
+#define assert_verbose(expr, msg)
+#define static_assert(expr, msg)
+
+#endif /* CONFIG_DEBUG */
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/byteorder.h
===================================================================
--- kernel/generic/include/byteorder.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/byteorder.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_BYTEORDER_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 #if !(defined(__BE__) ^ defined(__LE__))
Index: kernel/generic/include/cap/cap.h
===================================================================
--- kernel/generic/include/cap/cap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/cap/cap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,134 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_CAP_H_
+#define KERN_CAP_H_
+
+#include <typedefs.h>
+#include <adt/list.h>
+#include <adt/hash.h>
+#include <adt/hash_table.h>
+#include <lib/ra.h>
+#include <synch/mutex.h>
+#include <atomic.h>
+
+typedef int cap_handle_t;
+
+typedef enum {
+	CAP_STATE_FREE,
+	CAP_STATE_ALLOCATED,
+	CAP_STATE_PUBLISHED
+} cap_state_t;
+
+typedef enum {
+	KOBJECT_TYPE_PHONE,
+	KOBJECT_TYPE_IRQ,
+	KOBJECT_TYPE_MAX
+} kobject_type_t;
+
+struct task;
+struct phone;
+struct irq;
+
+struct kobject;
+typedef struct kobject_ops {
+	bool (*reclaim)(struct kobject *);
+	void (*destroy)(void *);
+} kobject_ops_t;
+
+/*
+ * Everything in kobject_t except for the atomic reference count is imutable.
+ */
+typedef struct kobject {
+	kobject_type_t type;
+	atomic_t refcnt;
+
+	kobject_ops_t *ops;
+
+	union {
+		void *raw;
+		struct phone *phone;
+		struct irq *irq;
+	};
+} kobject_t;
+
+/*
+ * A cap_t may only be accessed under the protection of the cap_info_t lock.
+ */
+typedef struct cap {
+	cap_state_t state;
+
+	struct task *task;
+	cap_handle_t handle;
+
+	/* Link to the task's capabilities of the same kobject type. */
+	link_t type_link;
+
+	ht_link_t caps_link;
+
+	/* The underlying kernel object. */
+	kobject_t *kobject;
+} cap_t;
+
+typedef struct cap_info {
+	mutex_t lock;
+
+	list_t type_list[KOBJECT_TYPE_MAX];
+
+	hash_table_t caps;
+	ra_arena_t *handles;
+} cap_info_t;
+
+extern void caps_init(void);
+extern int caps_task_alloc(struct task *);
+extern void caps_task_free(struct task *);
+extern void caps_task_init(struct task *);
+extern bool caps_apply_to_kobject_type(struct task *, kobject_type_t,
+    bool (*)(cap_t *, void *), void *);
+
+extern cap_handle_t cap_alloc(struct task *);
+extern void cap_publish(struct task *, cap_handle_t, kobject_t *);
+extern kobject_t *cap_unpublish(struct task *, cap_handle_t, kobject_type_t);
+extern void cap_free(struct task *, cap_handle_t);
+
+extern void kobject_initialize(kobject_t *, kobject_type_t, void *,
+    kobject_ops_t *);
+extern kobject_t *kobject_get(struct task *, cap_handle_t, kobject_type_t);
+extern void kobject_add_ref(kobject_t *);
+extern void kobject_put(kobject_t *);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/config.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,5 @@
 #ifndef __ASM__
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/generic/include/console/chardev.h
===================================================================
--- kernel/generic/include/console/chardev.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/console/chardev.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,6 @@
 
 #include <adt/list.h>
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 #include <synch/waitq.h>
 #include <synch/spinlock.h>
Index: kernel/generic/include/context.h
===================================================================
--- kernel/generic/include/context.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/context.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define KERN_CONTEXT_H_
 
-#include <typedefs.h>
 #include <trace.h>
 #include <arch/context.h>
